## This is the script for the Android Guitar(AG) Suite. This script serves as UI
## for the AG. The goal for this script is to allow the user to be able to 
## Create new projects, Open Existing projects, Delete Projects, and used the
## visualization tool. Throughout the script, the user will be prompted to 
## enter input. At any time during the script's execution ,the user can enter
## Ctrl-C to exit the program.

clear 
command=
filename=
 

## Developer's Note ##
# For the sake of testing, I left out the ./install -isb command until i can find 
# a way to run it in the background, which would allow the user to work while, if 
# neccesary, AG installs then dependecies

#i nabbed this off a dba forum
days_since_epoch() # args: year, month, day
{
  # returns (in $REPLY) the number of days since 1970/1/1 GMT
  # valid for any date in the limit of your integer size.
  # Expects y/m/d in the Gregorian calendar from 1752/9/14 on,
  # and in the Julian calendar until 1752/9/2. Note that even
  # though there were no days 3 nor 4 nor... 13 in September
  # 1752, if you provide those you will get the date in the
  # Gregorian calendar. days_since_epoch(1752, 9, 13) ==
  # days_since_epoch(1752, 9, 2).

  # "set" is used to avoid clobbering the variable namespace
  # with a temporary variable
  set -- "$((12 * ($1 + ($1 < 0)) + $2 - 3))" "$3"
  div "$1" 12
  set -- "$1" "$REPLY" "$2"
  div "$((367 * $1 + 7))" 12
  set -- "$1" "$2" "$3" "$REPLY"
  div "$2" 4
  set -- "$1" "$2" "$3" "$(($4 - 2 * $2 + $REPLY + $3))"
  if [ "$1" -eq 21030 ] && [ "$3" -lt 3 ] || [ "$1" -lt 21030 ]; then
    REPLY=$(($4 - 719471))
  else
    div "$2" 100
    set -- "$2" "$(($4 - $REPLY))"
    div "$1" 400
    REPLY=$(($2 + $REPLY - 719469))
  fi
}


# Using the trap command to capture the interupt command
trap goodbye INT


#function that causes the program to exit 
goodbye()
{
	echo -e "\nAre you sure you want to quit? Yes/No [Enter]"
	task=0
	while [ $task -eq 0 ]; do
		read response  
		shopt -s nocasematch
		case "$input" in
			y|yes|'') 
			echo "Goodbye"
			task=1
			exit;;
			n|no) 
			task=-1;;
			*) 
			echo "Invalid Ouput, Type either Yes or No [Enter]"
			task=0;;
		esac
	done
	shopt -u nocasematch
##Figure out a way to print instructions on return from goodbye.
}


#This function will delete the project's command from the AndroidGuitar folder. This function returns 
# nothing, but allows the user to return to the main menu .If invalid input is entered, the function 
# loop til proper input is provided. 
delete()
{
	wflag2=0
        while [ $wflag2 -eq 0 ]; do
		echo "Please enter file name"
        	read name
        	grep -w -q $name .run_cmds.txt
       		if [ $? -eq 0 ]; then
               		echo "Are you sure want to delete this command? Yes/No"
			task=0			
			while [ $task -eq 0 ]; do
				read response  
				shopt -s nocasematch
				case "$response" in
					y|yes|'') 
					sed -i '/$name /d' .run_cmds.txt
					sed -i '/$name /d' .app_list.txt
					echo "You will be directed back to the main menu now"	
					task=1
					wflag2=1;;
					n|no) echo 
					echo "You will be directed back to the main menu now"
					task=1
					wflag2=1
					;;
					*) 
					echo "Invalid Ouput, Type either Yes or No [Enter]"
					task=0;;
				esac
			done
		else
			echo "I'm sorry there is no project by that name , Please try again"
		fi
	done
	shopt -u nocasematch
}

#function for creating new projects. Note the build command is performed after projects information is entered
#works
new()
{
	echo  "Please enter the name of your app's folder and press [Enter]:"
	read name
	if [ -e .app_list.txt ]; then
		grep  -w $name .app_list.txt
		if [ $? -eq 0 ]; then 
			echo "alpha"
			task=0
			while [ $task -eq 0 ]; do
				echo "You already have a project by that name"
				echo "Do you want to use existing project: Yes/No"
			  	read response
				shopt -s nocasematch
				case "$input" in
					y|yes|'') 
					open
					task=1
					;;
					n|no)
					task1=1
					while [ $task1 -eq 0 ]; do					
						echo "Do you want to delete this project? Yes/No"
						read response
						case "$response" in
							y|yes|'') 
								delete
								task=1
								;;
							n|no) 
								task=1
								echo "Taking you back to the Main Menu"
								;;
							*) 
							echo "Invalid Ouput, Type either Yes or No [Enter]"
							;;
						esac
					done
					;;
					*)
					echo "Invalid Ouput, Type either Yes or No [Enter]"
				esac			
			done
		else
			echo "Please enter the path of your app's main class file and press [Enter]:"
			read path
			echo "Please enter the name of your app's main class [Enter]:"
			read activityName
			echo $name >> .app_list.txt
			echo "./adr-sample-workflow-nofaults.sh" $name $path $activityName >> .run_cmds.txt
			./build.sh $name #Build Command
		fi
	else
		echo "Please enter the path of your app's main class file and press [Enter]:"
		read path
		echo "Please enter the name of your app's main class [Enter]:"
		read activityName
		echo $name >> .app_list.txt
		echo "./adr-sample-workflow-nofaults.sh" $name $path $activityName >> .run_cmds.txt
		./build.sh $name #Build Command
	fi
	shopt -u nocasematch			
}


#This function just opens an prexsisting project. Note for later development and use: The Open command
# will handle two cases. 1: If the user hasn't altered their project. In this case the function will 
# not build again. 2: The user did alter their project (how to figure out how to do this is in dev)
# then the function would build.	
open()
{
        echo "Please enter file name"
        read name
        cmd=$(grep -w --count $name .run_cmds.txt)
        if [ $cmd -eq 1 ]; then
                command="$(grep -w $name .run_cmds.txt)"
        else
                wflag2=0
		echo $wflag2
                while [ $wflag2 -eq 0 ]; do
                        echo "I'm sorry there is no project by that name , Please try again"
                        read name
                        cmd=$(grep -w --count $name .run_cmds.txt)
                        if [ $cmd -eq 1 ];
                                then
                                command="$(grep -w $name .run_cmds.txt)"
                                wflag2=1
                        fi
                done
        fi
			#Detect changes in the .apk or activityclass(?)
                        #If they are new , rebuild , go on
	
        run "$name"                

}


# This is a sub-fuction of edit. It takes in a command string and through the calling process, the argument is 
# already parse. This function returns an edited version of the original command passed in. If invalid input
# is entered, the function loop til proper input is provided. 
editor()
{
	wflag2=0
	while [ $wflag2 -eq 0 ]; do
		echo "Which part of the command do you wish to edit? App's name [N], App's main class file [MC], app's file path [FP]"
		read response
		shopt -s nocasematch
		case "$input" in
		n) 
			echo "App Name: $2"
			echo "Please enter the new App Name"
			read AppName
			sed -i '/$AppName /d' .run_cmds.txt
			command="$1 $AppName $3 $4"
			"$command" > .run_cmds.txt
			wflag2=1
		;;
		mc) 
			echo "Main Class: $3"
			echo "Please enter the new Main Class"
			read MainClass
			sed -i '/$MainClass /d' .run_cmds.txt
			command="$1 $2 $MainClass $4"
			"$command" > .run_cmds.txt
		;;
		fp)
			echo "App's Main Class File Path:$4"
			echo "Please enter the new Main Class File Path"
			read FilePath
			sed -i '/$FilePath /d' .run_cmds.txt
			command="$1 $2 $3 $FilePath"
			"$command" > .run_cmds.txt
			wflag2=1
		;; 
		*) 
		echo -e "\nInvalid Output, Please Try Again.";;
		esac
	done
}


edit()
{
wflag2=0
        while [ $wflag2 -eq 0 ]; do
		echo "Please enter file name"
        	read name
        	cmd=$(grep -w --count $name .run_cmds.txt)
       		if [ $cmd -eq 1 ]; then
               		echo "Are you sure want to edit this command? Yes/No"
			task=0			
			while [ $task -eq 0 ]; do
				read response  
				shopt -s nocasematch
				case "$input" in
					y|yes|'') 
					command="$(grep -w $name run_cmds.txt)"					
					editor $command
					task=1
					wflag2=1
					;;
					n|no) 
					echo "You will be directed back to the main menu now"
					task=1
					wflag2=1
					;;
					*) 
					echo "Invalid Ouput, Type either Yes or No [Enter]"
					;;
				esac
			done
		else
			echo "I'm sorry there is no project by that name , Please try again"
		fi
	done
}


#Running AndroidGuitar#
run(){
	#./setup-tools.sh
	echo "Rebuilding project"
	./build.sh "$name" 
	cmd=$1
	echo "$cmd"
	./run.sh "$cmd"
}
 
visualize(){
	echo "Please enter file name"
	shopt -s nocasematch
        read name
        cmd=$(grep -w --count $name .run_cmds.txt)
        if [ $cmd -eq 0 ]; then
        	wflag2=0
		echo $wflag2
                while [ $wflag2 -eq 0 ]; do
                        echo "I'm sorry there is no project by that name , Please try again"
                        read name
                        cmd=$(grep -w --count $name .run_cmds.txt)
                        if [ $cmd -eq 1 ]; then
				wflag2=1
                        fi
                done
	fi
	#debug=$(! -d ~/data/"$name" )
	#echo "$debug"
	cd data
	ls
	if [[ -d "$name" && -f "$name"/"$name".EFG && -f "$name"/"$name".GUI ]]; then
		
		echo "good"
		cd ../guitar/dist/guitar/jars/guitar-lib
		java -jar gui-visualizer-adr.jar "$name"
	else
		cd ..
		echo "You do not have the necessary files to run the Visualization software"
		echo "Do you want to run the Ripper: Yes/No"
		task=0
		while [ $task -eq 0 ]; do
			read response  
			shopt -s nocasematch
			case "$input" in
				y|yes|'') 
				command="$(grep -w $name .run_cmds.txt)"					
				run $command
				task=1
				;;
				n|no) 
				echo "You will be directed back to the main menu now"
				task=1
				;;
				*) 
				echo "Invalid Ouput, Type either Yes or No [Enter]"
				;;
			esac
		done
					
	fi

             
}


echo "Hello user, welcome to AndroidGuitar"
flag=0
while [ $flag -ne 1 ]; do 
echo -e "\nType New to start a new project"
echo -e "Type Open to open an existing project"
echo -e "Type Delete to delete an existing project"
echo -e "Type Edit to edit an existing project"
echo -e "Type Visualize to run project visualizer"
echo -e "Type Help for the FAQ/Help Guide"
echo -e "Type Exit to exit the program"
read option
shopt -s nocasematch
case "$option" in
	New|new|n)
		new		
		flag=1
		;;
	Open|open|o) 
		open
		flag=1
		;;
	Delete|delete|d)
		delete
		flag=1;;
	Edit|edit|e)
		edit
		flag=1;;
	Visualize|visualize|v)
		flag=0
		visualize
		cd ~/acousticDemo/android
		;;
	Help|help|h)
		echo "Help"
		flag=1
		;;
	Exit|exit|ex)
		exit
		;;
	*) echo "invalid";;
esac
done

#########################################################################




touch -m .scriptlogs.txt 
#This should be one of the final commands of AndroidGuitar its used for the open
#method.



