#!/bin/bash

# $1 - Directory name for the to-be-built project
aut_directory=$1

# Check to make sure the android sdk is installed
if [ ! -f $HOME/android-sdk-linux/tools/android ]; then
    echo -e "==> You should first run setup-tool.sh.\n"
    exit -1
fi

# Set the path to include android
tools_path="$HOME/android-sdk-linux/tools:$HOME/android-sdk-linux/platform-tools"
original_PATH=${PATH}
export PATH=${PATH}:${tools_path}

# Extract the necessary lib archives
cd resign
tar xvf lib.tar
cd ../adr-server/libs
tar xvf lib.tar
cd ../../

# AUT Building
echo -e "==> Build AUT"
cd $aut_directory

if [ -f build.xml ]; then
    rm build.xml
fi

if [ -f libs/lib.tar ]; then
    cd libs
    tar xvf lib.tar
    cd ..
fi

# Set POSIX mode
set +o posix

# Set the target android API and build the project accordingly
android update project --target android-8 -p .
cp -rf src src.orig
ant clean
ant instrument
../resign.sh ./bin/*-instrumented.apk ./bin/aut-resigned.apk
mkdir -p ./bin/no_fault
cp ./bin/aut-resigned.apk ./bin/no_fault
cp coverage.em ./bin/no_fault

#while read line
#do
#    filename=${line##*/}
#    pathname=${line%/*}
#    original_path=`find src -name $filename`
#    echo "==> Fault seeded source file: $line"
#    cp $line $original_path
#    ant instrument
#    ../resign.sh ./bin/*-instrumented.apk ./bin/aut-resigned.apk
#    mkdir -p ./bin/$pathname
#    cp ./bin/aut-resigned.apk ./bin/$pathname
#    cp coverage.em ./bin/$pathname
#done < <( find result -name *.java )

rm -rf src
mv src.orig src
rm -rf bin/*.apk
