#!/bin/bash

old_dir=`pwd`

# Install openjdk-6 if it is not installed
if [ ! -d "/usr/lib/jvm/java-1.6.0-openjdk" ]; then
    echo "==> Installing openjdk-6"
    sudo apt-get -y install openjdk-6-jdk openjdk-6-jre
fi

# Install ant if it is not installed
command -v ant >/dev/null 2>&1 || { echo "==> Installing Ant"; sudo apt-get -y install ant; }
	
# Install svn if it is not installed
command -v svn >/dev/null 2>&1 || { echo "==> Installing Subversion"; sudo apt-get -y install subversion; }

# Install python if it is not installed
command -v python >/dev/null 2>&1 || { echo "==> Installing Python"; sudo apt-get -y install python; }

found=$(which android)
if [ $found ]; then
    echo -e "==> Android SDK already installed, skipping install.\n"
else
    if [ -f $HOME/android-sdk-linux/tools/android ]; then
        echo -e "==> Android SDK detected.\n"
    else
        echo -e "==> Download Android SDK"
		cd $HOME
        downloader=$(which wget)
        if [ $downloader ]; then
            wget http://dl.google.com/android/android-sdk_r15-linux.tgz
        else
            curl http://dl.google.com/android/android-sdk_r15-linux.tgz > android-sdk_r15-linux.tgz
        fi

        echo -e "==> Uncompress Android SDK"
        tar xvfz android-sdk_r15-linux.tgz
		rm android-sdk_r15-linux.tgz
    fi
	
    tools_path="$HOME/android-sdk-linux/tools:$HOME/android-sdk-linux/platform-tools"
    original_PATH=${PATH}
    export PATH=${PATH}:${tools_path}
    android update sdk --no-ui -t tool
    android update sdk --no-ui -t platform-tool
    android update sdk --no-ui -t platform
fi

cd $old_dir
rm -rf guitar
svn co -q http://subversion.assembla.com/svn/androidguitar/trunk/AndroidGUITAR guitar
cd guitar
ant -q adr.dist
cd dist/guitar
chmod +x `find . -name '*.sh'`
cd adr-aut
rm -rf *

export PATH=$original_PATH
